]> asedeno.scripts.mit.edu Git - git.git/blob - git-merge.sh
git-rev-parse --parseopt
[git.git] / git-merge.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5
6 OPTIONS_KEEPDASHDASH=
7 OPTIONS_SPEC="\
8 git-merge [options] <remote>...
9 git-merge [options] <msg> HEAD <remote>
10 --
11 summary              show a diffstat at the end of the merge
12 n,no-summary         don't show a diffstat at the end of the merge
13 squash               create a single commit instead of doing a merge
14 commit               perform a commit if the merge sucesses (default)
15 ff                   allow fast forward (default)
16 s,strategy=          merge strategy to use
17 m,message=           message to be used for the merge commit (if any)
18 "
19
20 SUBDIRECTORY_OK=Yes
21 . git-sh-setup
22 require_work_tree
23 cd_to_toplevel
24
25 test -z "$(git ls-files -u)" ||
26         die "You are in the middle of a conflicted merge."
27
28 LF='
29 '
30
31 all_strategies='recur recursive octopus resolve stupid ours subtree'
32 default_twohead_strategies='recursive'
33 default_octopus_strategies='octopus'
34 no_fast_forward_strategies='subtree ours'
35 no_trivial_strategies='recursive recur subtree ours'
36 use_strategies=
37
38 allow_fast_forward=t
39 allow_trivial_merge=t
40
41 dropsave() {
42         rm -f -- "$GIT_DIR/MERGE_HEAD" "$GIT_DIR/MERGE_MSG" \
43                  "$GIT_DIR/MERGE_SAVE" || exit 1
44 }
45
46 savestate() {
47         # Stash away any local modifications.
48         git diff-index -z --name-only $head |
49         cpio -0 -o >"$GIT_DIR/MERGE_SAVE"
50 }
51
52 restorestate() {
53         if test -f "$GIT_DIR/MERGE_SAVE"
54         then
55                 git reset --hard $head >/dev/null
56                 cpio -iuv <"$GIT_DIR/MERGE_SAVE"
57                 git update-index --refresh >/dev/null
58         fi
59 }
60
61 finish_up_to_date () {
62         case "$squash" in
63         t)
64                 echo "$1 (nothing to squash)" ;;
65         '')
66                 echo "$1" ;;
67         esac
68         dropsave
69 }
70
71 squash_message () {
72         echo Squashed commit of the following:
73         echo
74         git log --no-merges ^"$head" $remoteheads
75 }
76
77 finish () {
78         if test '' = "$2"
79         then
80                 rlogm="$GIT_REFLOG_ACTION"
81         else
82                 echo "$2"
83                 rlogm="$GIT_REFLOG_ACTION: $2"
84         fi
85         case "$squash" in
86         t)
87                 echo "Squash commit -- not updating HEAD"
88                 squash_message >"$GIT_DIR/SQUASH_MSG"
89                 ;;
90         '')
91                 case "$merge_msg" in
92                 '')
93                         echo "No merge message -- not updating HEAD"
94                         ;;
95                 *)
96                         git update-ref -m "$rlogm" HEAD "$1" "$head" || exit 1
97                         git gc --auto
98                         ;;
99                 esac
100                 ;;
101         esac
102         case "$1" in
103         '')
104                 ;;
105         ?*)
106                 if test "$show_diffstat" = t
107                 then
108                         # We want color (if set), but no pager
109                         GIT_PAGER='' git diff --stat --summary -M "$head" "$1"
110                 fi
111                 ;;
112         esac
113
114         # Run a post-merge hook
115         if test -x "$GIT_DIR"/hooks/post-merge
116         then
117             case "$squash" in
118             t)
119                 "$GIT_DIR"/hooks/post-merge 1
120                 ;;
121             '')
122                 "$GIT_DIR"/hooks/post-merge 0
123                 ;;
124             esac
125         fi
126 }
127
128 merge_name () {
129         remote="$1"
130         rh=$(git rev-parse --verify "$remote^0" 2>/dev/null) || return
131         bh=$(git show-ref -s --verify "refs/heads/$remote" 2>/dev/null)
132         if test "$rh" = "$bh"
133         then
134                 echo "$rh               branch '$remote' of ."
135         elif truname=$(expr "$remote" : '\(.*\)~[1-9][0-9]*$') &&
136                 git show-ref -q --verify "refs/heads/$truname" 2>/dev/null
137         then
138                 echo "$rh               branch '$truname' (early part) of ."
139         elif test "$remote" = "FETCH_HEAD" -a -r "$GIT_DIR/FETCH_HEAD"
140         then
141                 sed -e 's/      not-for-merge   /               /' -e 1q \
142                         "$GIT_DIR/FETCH_HEAD"
143         else
144                 echo "$rh               commit '$remote'"
145         fi
146 }
147
148 parse_config () {
149         while test $# != 0; do
150                 case "$1" in
151                 -n|--no-summary)
152                         show_diffstat=false ;;
153                 --summary)
154                         show_diffstat=t ;;
155                 --squash)
156                         allow_fast_forward=t squash=t no_commit=t ;;
157                 --no-squash)
158                         allow_fast_forward=t squash= no_commit= ;;
159                 --commit)
160                         allow_fast_forward=t squash= no_commit= ;;
161                 --no-commit)
162                         allow_fast_forward=t squash= no_commit=t ;;
163                 --ff)
164                         allow_fast_forward=t squash= no_commit= ;;
165                 --no-ff)
166                         allow_fast_forward=false squash= no_commit= ;;
167                 -s|--strategy)
168                         shift
169                         case " $all_strategies " in
170                         *" $1 "*)
171                                 use_strategies="$use_strategies$1 " ;;
172                         *)
173                                 die "available strategies are: $all_strategies" ;;
174                         esac
175                         ;;
176                 -m|--message)
177                         shift
178                         merge_msg="$1"
179                         have_message=t
180                         ;;
181                 --)
182                         shift
183                         break ;;
184                 *)      usage ;;
185                 esac
186                 shift
187         done
188         args_left=$#
189 }
190
191 test $# != 0 || usage
192
193 have_message=
194
195 if branch=$(git-symbolic-ref -q HEAD)
196 then
197         mergeopts=$(git config "branch.${branch#refs/heads/}.mergeoptions")
198         if test -n "$mergeopts"
199         then
200                 parse_config $mergeopts --
201         fi
202 fi
203
204 parse_config "$@"
205 while test $args_left -lt $#; do shift; done
206
207 if test -z "$show_diffstat"; then
208     test "$(git config --bool merge.diffstat)" = false && show_diffstat=false
209     test -z "$show_diffstat" && show_diffstat=t
210 fi
211
212 # This could be traditional "merge <msg> HEAD <commit>..."  and the
213 # way we can tell it is to see if the second token is HEAD, but some
214 # people might have misused the interface and used a committish that
215 # is the same as HEAD there instead.  Traditional format never would
216 # have "-m" so it is an additional safety measure to check for it.
217
218 if test -z "$have_message" &&
219         second_token=$(git rev-parse --verify "$2^0" 2>/dev/null) &&
220         head_commit=$(git rev-parse --verify "HEAD" 2>/dev/null) &&
221         test "$second_token" = "$head_commit"
222 then
223         merge_msg="$1"
224         shift
225         head_arg="$1"
226         shift
227 elif ! git rev-parse --verify HEAD >/dev/null 2>&1
228 then
229         # If the merged head is a valid one there is no reason to
230         # forbid "git merge" into a branch yet to be born.  We do
231         # the same for "git pull".
232         if test 1 -ne $#
233         then
234                 echo >&2 "Can merge only exactly one commit into empty head"
235                 exit 1
236         fi
237
238         rh=$(git rev-parse --verify "$1^0") ||
239                 die "$1 - not something we can merge"
240
241         git update-ref -m "initial pull" HEAD "$rh" "" &&
242         git read-tree --reset -u HEAD
243         exit
244
245 else
246         # We are invoked directly as the first-class UI.
247         head_arg=HEAD
248
249         # All the rest are the commits being merged; prepare
250         # the standard merge summary message to be appended to
251         # the given message.  If remote is invalid we will die
252         # later in the common codepath so we discard the error
253         # in this loop.
254         merge_name=$(for remote
255                 do
256                         merge_name "$remote"
257                 done | git fmt-merge-msg
258         )
259         merge_msg="${merge_msg:+$merge_msg$LF$LF}$merge_name"
260 fi
261 head=$(git rev-parse --verify "$head_arg"^0) || usage
262
263 # All the rest are remote heads
264 test "$#" = 0 && usage ;# we need at least one remote head.
265 set_reflog_action "merge $*"
266
267 remoteheads=
268 for remote
269 do
270         remotehead=$(git rev-parse --verify "$remote"^0 2>/dev/null) ||
271             die "$remote - not something we can merge"
272         remoteheads="${remoteheads}$remotehead "
273         eval GITHEAD_$remotehead='"$remote"'
274         export GITHEAD_$remotehead
275 done
276 set x $remoteheads ; shift
277
278 case "$use_strategies" in
279 '')
280         case "$#" in
281         1)
282                 var="`git config --get pull.twohead`"
283                 if test -n "$var"
284                 then
285                         use_strategies="$var"
286                 else
287                         use_strategies="$default_twohead_strategies"
288                 fi ;;
289         *)
290                 var="`git config --get pull.octopus`"
291                 if test -n "$var"
292                 then
293                         use_strategies="$var"
294                 else
295                         use_strategies="$default_octopus_strategies"
296                 fi ;;
297         esac
298         ;;
299 esac
300
301 for s in $use_strategies
302 do
303         for ss in $no_fast_forward_strategies
304         do
305                 case " $s " in
306                 *" $ss "*)
307                         allow_fast_forward=f
308                         break
309                         ;;
310                 esac
311         done
312         for ss in $no_trivial_strategies
313         do
314                 case " $s " in
315                 *" $ss "*)
316                         allow_trivial_merge=f
317                         break
318                         ;;
319                 esac
320         done
321 done
322
323 case "$#" in
324 1)
325         common=$(git merge-base --all $head "$@")
326         ;;
327 *)
328         common=$(git show-branch --merge-base $head "$@")
329         ;;
330 esac
331 echo "$head" >"$GIT_DIR/ORIG_HEAD"
332
333 case "$allow_fast_forward,$#,$common,$no_commit" in
334 ?,*,'',*)
335         # No common ancestors found. We need a real merge.
336         ;;
337 ?,1,"$1",*)
338         # If head can reach all the merge then we are up to date.
339         # but first the most common case of merging one remote.
340         finish_up_to_date "Already up-to-date."
341         exit 0
342         ;;
343 t,1,"$head",*)
344         # Again the most common case of merging one remote.
345         echo "Updating $(git rev-parse --short $head)..$(git rev-parse --short $1)"
346         git update-index --refresh 2>/dev/null
347         msg="Fast forward"
348         if test -n "$have_message"
349         then
350                 msg="$msg (no commit created; -m option ignored)"
351         fi
352         new_head=$(git rev-parse --verify "$1^0") &&
353         git read-tree -v -m -u --exclude-per-directory=.gitignore $head "$new_head" &&
354         finish "$new_head" "$msg" || exit
355         dropsave
356         exit 0
357         ;;
358 ?,1,?*"$LF"?*,*)
359         # We are not doing octopus and not fast forward.  Need a
360         # real merge.
361         ;;
362 ?,1,*,)
363         # We are not doing octopus, not fast forward, and have only
364         # one common.
365         git update-index --refresh 2>/dev/null
366         case "$allow_trivial_merge" in
367         t)
368                 # See if it is really trivial.
369                 git var GIT_COMMITTER_IDENT >/dev/null || exit
370                 echo "Trying really trivial in-index merge..."
371                 if git read-tree --trivial -m -u -v $common $head "$1" &&
372                    result_tree=$(git write-tree)
373                 then
374                         echo "Wonderful."
375                         result_commit=$(
376                                 printf '%s\n' "$merge_msg" |
377                                 git commit-tree $result_tree -p HEAD -p "$1"
378                         ) || exit
379                         finish "$result_commit" "In-index merge"
380                         dropsave
381                         exit 0
382                 fi
383                 echo "Nope."
384         esac
385         ;;
386 *)
387         # An octopus.  If we can reach all the remote we are up to date.
388         up_to_date=t
389         for remote
390         do
391                 common_one=$(git merge-base --all $head $remote)
392                 if test "$common_one" != "$remote"
393                 then
394                         up_to_date=f
395                         break
396                 fi
397         done
398         if test "$up_to_date" = t
399         then
400                 finish_up_to_date "Already up-to-date. Yeeah!"
401                 exit 0
402         fi
403         ;;
404 esac
405
406 # We are going to make a new commit.
407 git var GIT_COMMITTER_IDENT >/dev/null || exit
408
409 # At this point, we need a real merge.  No matter what strategy
410 # we use, it would operate on the index, possibly affecting the
411 # working tree, and when resolved cleanly, have the desired tree
412 # in the index -- this means that the index must be in sync with
413 # the $head commit.  The strategies are responsible to ensure this.
414
415 case "$use_strategies" in
416 ?*' '?*)
417     # Stash away the local changes so that we can try more than one.
418     savestate
419     single_strategy=no
420     ;;
421 *)
422     rm -f "$GIT_DIR/MERGE_SAVE"
423     single_strategy=yes
424     ;;
425 esac
426
427 result_tree= best_cnt=-1 best_strategy= wt_strategy=
428 merge_was_ok=
429 for strategy in $use_strategies
430 do
431     test "$wt_strategy" = '' || {
432         echo "Rewinding the tree to pristine..."
433         restorestate
434     }
435     case "$single_strategy" in
436     no)
437         echo "Trying merge strategy $strategy..."
438         ;;
439     esac
440
441     # Remember which strategy left the state in the working tree
442     wt_strategy=$strategy
443
444     git-merge-$strategy $common -- "$head_arg" "$@"
445     exit=$?
446     if test "$no_commit" = t && test "$exit" = 0
447     then
448         merge_was_ok=t
449         exit=1 ;# pretend it left conflicts.
450     fi
451
452     test "$exit" = 0 || {
453
454         # The backend exits with 1 when conflicts are left to be resolved,
455         # with 2 when it does not handle the given merge at all.
456
457         if test "$exit" -eq 1
458         then
459             cnt=`{
460                 git diff-files --name-only
461                 git ls-files --unmerged
462             } | wc -l`
463             if test $best_cnt -le 0 -o $cnt -le $best_cnt
464             then
465                 best_strategy=$strategy
466                 best_cnt=$cnt
467             fi
468         fi
469         continue
470     }
471
472     # Automerge succeeded.
473     result_tree=$(git write-tree) && break
474 done
475
476 # If we have a resulting tree, that means the strategy module
477 # auto resolved the merge cleanly.
478 if test '' != "$result_tree"
479 then
480     if test "$allow_fast_forward" = "t"
481     then
482         parents=$(git show-branch --independent "$head" "$@")
483     else
484         parents=$(git rev-parse "$head" "$@")
485     fi
486     parents=$(echo "$parents" | sed -e 's/^/-p /')
487     result_commit=$(printf '%s\n' "$merge_msg" | git commit-tree $result_tree $parents) || exit
488     finish "$result_commit" "Merge made by $wt_strategy."
489     dropsave
490     exit 0
491 fi
492
493 # Pick the result from the best strategy and have the user fix it up.
494 case "$best_strategy" in
495 '')
496         restorestate
497         case "$use_strategies" in
498         ?*' '?*)
499                 echo >&2 "No merge strategy handled the merge."
500                 ;;
501         *)
502                 echo >&2 "Merge with strategy $use_strategies failed."
503                 ;;
504         esac
505         exit 2
506         ;;
507 "$wt_strategy")
508         # We already have its result in the working tree.
509         ;;
510 *)
511         echo "Rewinding the tree to pristine..."
512         restorestate
513         echo "Using the $best_strategy to prepare resolving by hand."
514         git-merge-$best_strategy $common -- "$head_arg" "$@"
515         ;;
516 esac
517
518 if test "$squash" = t
519 then
520         finish
521 else
522         for remote
523         do
524                 echo $remote
525         done >"$GIT_DIR/MERGE_HEAD"
526         printf '%s\n' "$merge_msg" >"$GIT_DIR/MERGE_MSG"
527 fi
528
529 if test "$merge_was_ok" = t
530 then
531         echo >&2 \
532         "Automatic merge went well; stopped before committing as requested"
533         exit 0
534 else
535         {
536             echo '
537 Conflicts:
538 '
539                 git ls-files --unmerged |
540                 sed -e 's/^[^   ]*      /       /' |
541                 uniq
542         } >>"$GIT_DIR/MERGE_MSG"
543         git rerere
544         die "Automatic merge failed; fix conflicts and then commit the result."
545 fi